package Model;
import java.util.*;

/**
 * Ein Aktie
 * @author christoph
 */
public class Aktie {

    /**
     * 
     */
    public int index;
    /**
     * 
     */
    public String name;
    /**
     * 
     */
    public int paketanzahl;
    /**
     * 
     */
    public int[] verlauf;
    /**
     * 
     */
    public int kaufkurs;
    /**
     * 
     */
    public int startkurs;
    /**
     * 
     */
    public int bereichskurs;
    /**
     * 
     */
    public int tageshoch;
    /**
     * 
     */
    public int tagestief;
    /**
     * 
     */
    public int tendenz;
    /**
     * Zhler der gekauften oder verkauften Aktien
     */
    private int zhler;    
    

    /**
     * Anfangswerte: 1000 Pakete, Startkurs 20 Euro, Tendenz: 0
     * @param i Aktiennummer
     * @param n Aktienbezeichner
     */
    public Aktie(int i, String n){
        index= i;
        name= n;
        paketanzahl= 1000;
        startkurs= 20;
        verlauf= new int[8];
        for(int p=0; p<verlauf.length; p++){
            verlauf[p]= p+ startkurs;
        }

        tendenz= 0;
        zhler= 0;
        tageshoch= startkurs;
        tagestief= startkurs;
        bereichskurs= startkurs;
    }
    
    /**
     * Gibt den letzten Kurswert zurck.
     * @return letzter Kurswert
     */
    public int kursGeben(){
        return verlauf[0];
    }
    
    /**
     * Setzt den letzten Kurswert fest.
     * @param f letzter Kurswert
     */
    public void kursSetzen(int f){
        verlauf[0]= f;
    }
    
    /**
     * Bestimmt in Abhngigkeit von Kauf oder Verkauf, ob die Aktienstckzahl
     * positiv oder negativ gezhlt wird und 
     * setzt den Zhler der gekauften oder verkauften Aktien
     * @param c String kaufen oder verkaufen
     * @param pakete Anzahl der Aktienpakete
     */
    public void zhlerSetzen(String c, int pakete){
        if(c.compareTo("k")== 0){
            zhler= pakete;
        }
        else if(c.compareTo("v")== 0){
            zhler= (-1*pakete);
        }
    }
    
    /**
     * Aktualisiert Tageshoch und Tagestief
     */
    private void tagesHochTiefAktualisieren(){
        if(tageshoch < kursGeben()){
            tageshoch= kursGeben();
        }
        if(tagestief > kursGeben()){
            tagestief= kursGeben();
        }
    }
    
    /**
     * Aktualisiert die Tendenz
     */
    private void tendenzAktualisieren(){
        int t= 0;        
        for(int i=1; i< verlauf.length; i++){
            if(verlauf[i-1] > verlauf[i]){
                t= t+1;}
            else if(verlauf[i-1] == verlauf[i]){
                t= t+0;}
            else{
                t= t-1;}
        }
        if(t>0){
            tendenz= +1;}
        else if(t==0){
            tendenz= 0;}
        else{
            tendenz= -1;}
    }

    /**
     * Berechnet den nchsten Kurs und aktualisiert den Kursverlauf
     */
    public void kursVerlaufAktualisieren(){        
        //Verlauf aktualisiseren
        verlauf[7]=verlauf[6];
        verlauf[6]=verlauf[5];
        verlauf[5]=verlauf[4];
        verlauf[4]=verlauf[3];
        verlauf[3]=verlauf[2];
        verlauf[2]=verlauf[1];
        verlauf[1]=verlauf[0];
        
        //evtl. Startkurs akutalisieren
        if(kursGeben()== bereichskurs-20 || kursGeben()== bereichskurs+20){
            bereichskurs= kursGeben();
        }
        
        //Maximal und Minimalwerte abfangen
        if(kursGeben() < 15 || kursGeben() > 25){
            kursSetzen(20);
        }
       
        
        //Kursabhngige Faktoren aktualisieren
        kursBerechnen();
        tendenzAktualisieren();
        tagesHochTiefAktualisieren();        
    }
    
    public void kursBerechnen(){
        Random random= new Random();
        double zhler = (random.nextInt(10)-5);
        double nenner = (random.nextInt(4)+1);
        float i= (float)(zhler/nenner)+(float)(zhler/2);

        int k= verlauf[0]+ (int)i;

        if(this.zhler > 0){       
            kursSetzen(k+ (int)((1000/paketanzahl+1)));
            this.zhler--;
        }
        else if(this.zhler < 0){    
            kursSetzen(k- (int)((1000/paketanzahl+1)));
            this.zhler++;
        }
        else{
            kursSetzen(k);
        }
    }
}
