package Controller;  
import Model.Boerse;
import javax.swing.Timer;
import java.awt.event.*;


/**
 * Die Klasse Takt sorgt für einen gleichmäßigen, automatischen Ablauf des Programms.
 * @author christoph
 */
public class Takt implements ActionListener{

    /**
     * 
     */
    public Timer timer;
    /**
     * 
     */
    public Boerse boerse;
    /**
     * 
     */
    public boolean läuft;

    /**
     * Voreinstellung: 5000 ms Takt
     * @param b Boerse
     */
    public Takt(Boerse b){
        timer = new Timer(5000, this);
        boerse = b;
    }
    /**
     * Aktualisiert nach jedem Takt die Kurse der Aktien mit der Methode 
     * kursAktualisieren der Klasse Aktie und 
     * ruft nach jedem Takt die Methode kursAktualisieren() der Klasse Boerse auf.
     */
    public void actionPerformed (ActionEvent evt){
        for(int i=0; i< boerse.aktienliste.length; i++){
            boerse.aktienliste[i].kursVerlaufAktualisieren();
        }
        boerse.aktualisieren();
    }

    /**
     * Startet den Takt
     */
    public void starten(){
        timer.start();
        läuft= true;
    }

    /**
     * Stoppt den Takt
     */
    public void anhalten(){
        timer.stop();
        läuft= false;
    }

    /**
     * Setzt die Dauer eines Takts
     * @param dauer
     */
    public void intervallSetzen (int dauer){
        timer.setDelay(dauer);
    }

    /**
     * Gibt die Dauer eines Takts
     * @return int Delay
     */
    public int intervallGeben (){
        return timer.getDelay();
    }
}


