package Model;
import Controller.Takt;
import View.*;
import java.awt.Color;

/**
 * 
 * @author christoph
 */
public class Boerse {
    //Daten
    /**
     * 
     */
    public Benutzer benutzer;
    /**
     * 
     */
    public Aktie[] aktienliste;

    //Fenster
    private Depotdetails depotdetails= new Depotdetails();
    private Aktiendetails aktiendetails= new Aktiendetails();
    private Transaktionen transaktionen;
    /**
     * 
     */
    public BoersenFrame börsenframe;

    /**
     * 
     */
    public Takt takt;
    

    /**
     * Eine Börse mit einem Benutzer und einer Aktienliste;
     * Initialisieren des Hauptfensters
     * @param b Benutzer
     * @param al Aktienliste
     */
    public Boerse(Benutzer b, Aktie[] al) {
        benutzer= b;
        aktienliste= al;
        börsenframe= new BoersenFrame(this, aktiendetails, depotdetails, aktienliste);
        börsenframe.setVisible(true);
        aktiendetails.setAktienliste(aktienliste);

        //Erstellen des Taktgebers
        takt= new Takt(this);
        takt.intervallSetzen(5000);
        takt.starten();

    }

    /**
     * Übergibt an das Fenster Standardwerte zum Anzeigen
     */
    public void standardWerteUebergeben(){
        int länge= aktienliste.length;
        börsenframe.setLabelText(47,benutzer.depotnummerGeben());
        if(länge>=1){
            börsenframe.setLabelText(4,"0"+aktienliste[0].index);
            börsenframe.setLabelText(6,aktienliste[0].name);
            if(länge>=2){
                börsenframe.setLabelText(11,"0"+aktienliste[1].index);
                börsenframe.setLabelText(12,aktienliste[1].name);
                if(länge>=3){
                    börsenframe.setLabelText(15,"0"+aktienliste[2].index);
                    börsenframe.setLabelText(16,aktienliste[2].name);
                    if(länge>=4){
                        börsenframe.setLabelText(19,"0"+aktienliste[3].index);
                        börsenframe.setLabelText(20,aktienliste[3].name);
                        if(länge>=5){
                            börsenframe.setLabelText(23,"0"+aktienliste[4].index);
                            börsenframe.setLabelText(24,aktienliste[4].name);
                            if(länge>=6){
                                börsenframe.setLabelText(27,"0"+aktienliste[5].index);
                                börsenframe.setLabelText(28,aktienliste[5].name);
                            }
                        }
                    }
                }
            }
        }                    
    }
    
    /**
     * Aktualisiert das Börsen-Hauptfenster
     */
    private void börseAktualisieren(){
        float[] c= java.awt.Color.RGBtoHSB(21, 147, 47, null);
        int länge= aktienliste.length;
        if(länge >=1){
            börsenframe.setLabelText(9,""+aktienliste[0].paketanzahl);
            if(aktienliste[0].kursGeben()< aktienliste[0].verlauf[1]){
                börsenframe.setLabelText(10,""+aktienliste[0].kursGeben()+" ↘");
                börsenframe.setLabelForeground(10 ,Color.red);}
            else if(aktienliste[0].kursGeben()== aktienliste[0].verlauf[1]){
                börsenframe.setLabelText(10,""+aktienliste[0].kursGeben()+" →");
                börsenframe.setLabelForeground(10 ,Color.gray);}
            else{
                börsenframe.setLabelText(10,""+aktienliste[0].kursGeben()+" ↗");
                börsenframe.setLabelForeground(10 ,Color.getHSBColor(c[0], c[1], c[2]));}
            if(länge >=2){
                börsenframe.setLabelText(13,""+aktienliste[1].paketanzahl);
                if(aktienliste[1].kursGeben()< aktienliste[1].verlauf[1]){
                    börsenframe.setLabelText(14,""+aktienliste[1].kursGeben()+" ↘");
                    börsenframe.setLabelForeground(14 ,Color.red);}
                else if(aktienliste[1].kursGeben()== aktienliste[1].verlauf[1]){
                    börsenframe.setLabelText(14,""+aktienliste[1].kursGeben()+" →");
                    börsenframe.setLabelForeground(14 ,Color.gray);}
                else{
                    börsenframe.setLabelText(14,""+aktienliste[1].kursGeben()+" ↗");
                    börsenframe.setLabelForeground(14 ,Color.getHSBColor(c[0], c[1], c[2]));}
                if(länge >=3){
                    börsenframe.setLabelText(17,""+aktienliste[2].paketanzahl);
                    if(aktienliste[2].kursGeben()< aktienliste[2].verlauf[1]){
                        börsenframe.setLabelText(18,""+aktienliste[2].kursGeben()+" ↘");
                        börsenframe.setLabelForeground(18 ,Color.red);}
                    else if(aktienliste[2].kursGeben()== aktienliste[2].verlauf[1]){
                        börsenframe.setLabelText(18,""+aktienliste[2].kursGeben()+" →");
                        börsenframe.setLabelForeground(18 ,Color.gray);}
                    else{
                        börsenframe.setLabelText(18,""+aktienliste[2].kursGeben()+" ↗");
                        börsenframe.setLabelForeground(18 ,Color.getHSBColor(c[0], c[1], c[2]));}
                    if(länge >=4){
                        börsenframe.setLabelText(21,""+aktienliste[3].paketanzahl);
                        if(aktienliste[3].kursGeben()< aktienliste[3].verlauf[1]){
                            börsenframe.setLabelText(22,""+aktienliste[3].kursGeben()+" ↘");
                            börsenframe.setLabelForeground(22 ,Color.red);}
                        else if(aktienliste[3].kursGeben()== aktienliste[3].verlauf[1]){
                            börsenframe.setLabelText(22,""+aktienliste[3].kursGeben()+" →");
                            börsenframe.setLabelForeground(22 ,Color.gray);}
                        else{
                            börsenframe.setLabelText(22,""+aktienliste[3].kursGeben()+" ↗");
                            börsenframe.setLabelForeground(22 ,Color.getHSBColor(c[0], c[1], c[2]));}
                        if(länge >=5){
                            börsenframe.setLabelText(25,""+aktienliste[4].paketanzahl);
                            if(aktienliste[4].kursGeben()< aktienliste[4].verlauf[1]){
                                börsenframe.setLabelText(26,""+aktienliste[4].kursGeben()+" ↘");
                                börsenframe.setLabelForeground(26 ,Color.red);}
                            else if(aktienliste[4].kursGeben()== aktienliste[4].verlauf[1]){
                                börsenframe.setLabelText(26,""+aktienliste[4].kursGeben()+" →");
                                börsenframe.setLabelForeground(26 ,Color.gray);}
                            else{
                                börsenframe.setLabelText(26,""+aktienliste[4].kursGeben()+" ↗");
                                börsenframe.setLabelForeground(26 ,Color.getHSBColor(c[0], c[1], c[2]));}
                            if(länge >=6){
                                börsenframe.setLabelText(29,""+aktienliste[5].paketanzahl);
                                if(aktienliste[5].kursGeben()< aktienliste[5].verlauf[1]){
                                    börsenframe.setLabelText(30,""+aktienliste[5].kursGeben()+" ↘");
                                    börsenframe.setLabelForeground(30 ,Color.red);}
                                else if(aktienliste[5].kursGeben()== aktienliste[5].verlauf[1]){
                                    börsenframe.setLabelText(30,""+aktienliste[5].kursGeben()+" →");
                                    börsenframe.setLabelForeground(30 ,Color.gray);}
                                else{
                                    börsenframe.setLabelText(30,""+aktienliste[5].kursGeben()+" ↗");
                                    börsenframe.setLabelForeground(30 ,Color.getHSBColor(c[0], c[1], c[2]));}
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * Aktualisiert die Anzeige der Aktien in der Depot-Spalte des Börsen-Fensters
     */
    private void depotAktualisieren(){
        float[] n= java.awt.Color.RGBtoHSB(62, 121, 121, null);
        float[] h= java.awt.Color.RGBtoHSB(143, 17, 17, null);
        if(benutzer.getDepotInhalt(0) != null && aktienliste[0] != null){
            börsenframe.setLabelText(32,""+benutzer.getDepotInhalt(0).paketanzahl);
            börsenframe.setLabelText(39,""+benutzer.getDepotInhalt(0).kaufkurs);
            if(benutzer.getDepotInhalt(0).kaufkurs < aktienliste[0].kursGeben()){
                börsenframe.setLabelForeground(39 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(39 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(32,"--");
            börsenframe.setLabelText(39,"--");
            börsenframe.setLabelForeground(39 ,Color.BLACK);}
        if(benutzer.getDepotInhalt(1) != null && aktienliste[1] != null){
            börsenframe.setLabelText(33,""+benutzer.getDepotInhalt(1).paketanzahl);
            börsenframe.setLabelText(40,""+benutzer.getDepotInhalt(1).kaufkurs);
            if(benutzer.getDepotInhalt(1).kaufkurs < aktienliste[1].kursGeben()){
                börsenframe.setLabelForeground(40 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(40 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(33,"--");
            börsenframe.setLabelText(40,"--");
            börsenframe.setLabelForeground(40 ,Color.BLACK);}
        if(benutzer.getDepotInhalt(2) != null && aktienliste[2] != null){
            börsenframe.setLabelText(34,""+benutzer.getDepotInhalt(2).paketanzahl);
            börsenframe.setLabelText(41,""+benutzer.getDepotInhalt(2).kaufkurs);
            if(benutzer.getDepotInhalt(2).kaufkurs < aktienliste[2].kursGeben()){
                börsenframe.setLabelForeground(41 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(41 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(34,"--");
            börsenframe.setLabelText(41,"--");
            börsenframe.setLabelForeground(41 ,Color.BLACK);}
        if(benutzer.getDepotInhalt(3) != null && aktienliste[3] != null){
            börsenframe.setLabelText(35,""+benutzer.getDepotInhalt(3).paketanzahl);
            börsenframe.setLabelText(42,""+benutzer.getDepotInhalt(3).kaufkurs);
            if(benutzer.getDepotInhalt(3).kaufkurs < aktienliste[3].kursGeben()){
                börsenframe.setLabelForeground(42 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(42 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(35,"--");
            börsenframe.setLabelText(42,"--");
            börsenframe.setLabelForeground(42 ,Color.BLACK);}
        if(benutzer.getDepotInhalt(4) != null && aktienliste[4] != null){
            börsenframe.setLabelText(36,""+benutzer.getDepotInhalt(4).paketanzahl);
            börsenframe.setLabelText(43,""+benutzer.getDepotInhalt(4).kaufkurs);
            if(benutzer.getDepotInhalt(4).kaufkurs < aktienliste[4].kursGeben()){
                börsenframe.setLabelForeground(43 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(43 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(36,"--");
            börsenframe.setLabelText(43,"--");
            börsenframe.setLabelForeground(43 ,Color.BLACK);}
        if(benutzer.getDepotInhalt(5) != null && aktienliste[5] != null){
            börsenframe.setLabelText(37,""+benutzer.getDepotInhalt(5).paketanzahl);
            börsenframe.setLabelText(44,""+benutzer.getDepotInhalt(5).kaufkurs);
            if(benutzer.getDepotInhalt(5).kaufkurs < aktienliste[5].kursGeben()){
                börsenframe.setLabelForeground(44 ,Color.getHSBColor(n[0], n[1], n[2]));}
            else{
                börsenframe.setLabelForeground(44 ,Color.getHSBColor(h[0], h[1], h[2]));}}
        else{
            börsenframe.setLabelText(37,"--");
            börsenframe.setLabelText(44,"--");
            börsenframe.setLabelForeground(44 ,Color.BLACK);}
    }


    /**
     * Ruft nacheinander die Methoden zum Aktualisieren der Fenster auf.
     */
    public void aktualisieren(){
        standardWerteUebergeben();
        börseAktualisieren();
        depotAktualisieren();
        depotdetails.aktualisieren(benutzer, aktienliste);
        //aktiendetails.aktualisieren(aktienliste);
    }
    
    /**
     * Methode zum Kaufen von Aktien
     * @param index Aktiennummer
     * @param stueckzahl Stückzahl
     */
    public void kaufen(int index, int stueckzahl){
        int konto= benutzer.kontostandGeben();
        if(index >= 0 && index < aktienliste.length){
            if (stueckzahl > 0){
                //Wenn nicht genug auf dem Konto liegt, dann wird die Stückzahl verkleinert
                if(!(stueckzahl <= aktienliste[index].paketanzahl && stueckzahl*aktienliste[index].kursGeben()< konto)){
                    stueckzahl = (int)(konto/aktienliste[index].kursGeben());
                }
                //kaufen
                benutzer.kontostandSetzen((int)(konto- stueckzahl*aktienliste[index].kursGeben()));
                int a= aktienliste[index].paketanzahl- stueckzahl;
                aktienliste[index].paketanzahl= a;
                
                //Wenn die Aktie schon im Depot liegt ...
                if(benutzer.getDepotInhalt(index) != null){
                    int b= (benutzer.getDepotInhalt(index)).paketanzahl+ stueckzahl;
                    benutzer.getDepotInhalt(index).paketanzahl= b;
                }
                else{
                    benutzer.setDepotInhalt(new Aktie(index, aktienliste[index].name), index);
                    benutzer.getDepotInhalt(index).paketanzahl= stueckzahl;
                }
                benutzer.getDepotInhalt(index).kaufkurs= aktienliste[index].kursGeben();
                aktienliste[index].zählerSetzen("k", stueckzahl);
                aktualisieren();
            }
            else {
                    javax.swing.JOptionPane.showMessageDialog(null, "Eingegebene Stückzahl nicht möglich.", "Achtung", javax.swing.JOptionPane.OK_CANCEL_OPTION);
            }
        }
        else {
            javax.swing.JOptionPane.showMessageDialog(null, "Keine passende Aktie gefunden.", "Achtung", javax.swing.JOptionPane.OK_CANCEL_OPTION);
        }

    }
    
    /**
     * Methode zum Verkaufen von Aktien
     * @param index Aktiennummer
     * @param stueckzahl Stückzahl
     */
    public void verkaufen(int index, int stueckzahl){
        if(index >=0 && index < aktienliste.length){
            if (stueckzahl > 0){
                if(benutzer.getDepotInhalt(index) != null){
                    int umsatz=0;
                    int paal=0;
                    if(stueckzahl >= benutzer.getDepotInhalt(index).paketanzahl){
                        umsatz= (int)(benutzer.getDepotInhalt(index).paketanzahl * aktienliste[index].kursGeben());
                        paal= aktienliste[index].paketanzahl + benutzer.getDepotInhalt(index).paketanzahl;
                        benutzer.setDepotInhalt(null, index);
                    }
                    else{
                        int pabe=0;
                        umsatz= (int)(aktienliste[index].kursGeben()*stueckzahl);
                        pabe= benutzer.getDepotInhalt(index).paketanzahl- stueckzahl;
                        paal= aktienliste[index].paketanzahl+ stueckzahl;
                        benutzer.getDepotInhalt(index).paketanzahl= pabe;
                    }
                benutzer.kontostandSetzen(benutzer.kontostandGeben()+ umsatz);
                aktienliste[index].paketanzahl= paal;
                aktienliste[index].zählerSetzen("v", stueckzahl);
                aktualisieren();
                }
            }
            else {
            javax.swing.JOptionPane.showMessageDialog(null, "Eingegebene Stückzahl nicht möglich.", "Achtung", javax.swing.JOptionPane.OK_CANCEL_OPTION);
            }
        }
        else {
            javax.swing.JOptionPane.showMessageDialog(null, "Keine passende Aktie gefunden.", "Achtung", javax.swing.JOptionPane.OK_CANCEL_OPTION);
        }
    }
    
    /**
     * 
     */
    public void defaultSetzen(){
        
        börsenframe.setLabelText(4,"--");
        börsenframe.setLabelText(6,"--");
        börsenframe.setLabelText(9,"--");
        börsenframe.setLabelText(10,"--");
        börsenframe.setLabelText(11,"--");
        börsenframe.setLabelText(12,"--");
        börsenframe.setLabelText(13,"--");
        börsenframe.setLabelText(14,"--");
        börsenframe.setLabelText(15,"--");
        börsenframe.setLabelText(16,"--");
        börsenframe.setLabelText(17,"--");
        börsenframe.setLabelText(18,"--");
        börsenframe.setLabelText(19,"--");
        börsenframe.setLabelText(20,"--");
        börsenframe.setLabelText(21,"--");
        börsenframe.setLabelText(22,"--");
        börsenframe.setLabelText(23,"--");
        börsenframe.setLabelText(24,"--");
        börsenframe.setLabelText(25,"--");
        börsenframe.setLabelText(26,"--");
        börsenframe.setLabelText(27,"--");
        börsenframe.setLabelText(28,"--");
        börsenframe.setLabelText(29,"--");
        börsenframe.setLabelText(30,"--");

        börsenframe.setLabelText(32,"--");
        börsenframe.setLabelText(33,"--");
        börsenframe.setLabelText(34,"--");
        börsenframe.setLabelText(35,"--");
        börsenframe.setLabelText(36,"--");
        börsenframe.setLabelText(37,"--");
        börsenframe.setLabelText(39,"--");
        börsenframe.setLabelText(40,"--");
        börsenframe.setLabelText(41,"--");
        börsenframe.setLabelText(42,"--");
        börsenframe.setLabelText(43,"--");
        börsenframe.setLabelText(44,"--");
    }
}
