package View;
import javax.swing.*;
import Model.*;
/**
 * Hauptfenster der Börse
 * @author christoph
 */
public class BoersenFrame extends JFrame {

    private Boerse boerse;
    private Aktiendetails aktiendetails;
    private Depotdetails depotdetails;
    private Aktie[] aktienliste;
    private Transaktionen transaktionen;
        
    
        // Alle Komponenten des Hauptfensters
        private JLabel[] labels = new JLabel[48]; 
    
        private JPanel jPanel1 = new JPanel();
        private JPanel jPanel2 = new JPanel();
        private JPanel jPanel3 = new JPanel();
        private JPanel jPanel4 = new JPanel();
    
        private JTextField jTextField1 = new JTextField();
        
        private JButton jButton1 = new JButton();
        private JButton jButton2 = new JButton();
        private JButton jButton9 = new JButton();
        private JButton jButton5 = new JButton();
        
        private JSeparator jSeparator1 = new JSeparator();
        private JSeparator jSeparator2 = new JSeparator();
        private JSeparator jSeparator3 = new JSeparator();
        
        
        /**
        *  Hauptfenster der Börse
         * @param b Börse
         * @param ad Aktiendetails
         * @param dd Depotdetails
         * @param al Aktienliste
         */
        public BoersenFrame(Boerse b, Aktiendetails ad, Depotdetails dd, Aktie[] al){
        aktiendetails = ad;
        depotdetails = dd;
        aktienliste = al;
        transaktionen= new Transaktionen(b);
        setTitle("Börsensimulation");  
        for (int i=0;i<labels.length;i++){
            labels[i]=new JLabel();
        }
        setLocation(200, 300);
        setVisible(true);
        initComponents();
    }

    /**
    * Initialisiert die Komponenten und setzt die Anfangsbeschriftung
    * und die Anfangsgröße des Hauptfensters auf (600,500)
    * 
    */
    private void initComponents() {
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        labels[3].setForeground(new java.awt.Color(20, 112, 173));
        labels[3].setText("Index");
        labels[5].setForeground(new java.awt.Color(21, 113, 173));
        labels[5].setText("Name");
        labels[7].setForeground(new java.awt.Color(21, 116, 173));
        labels[7].setText("Pakete");
        labels[8].setForeground(new java.awt.Color(21, 116, 173));
        labels[8].setText("Kurs (€)");


        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING, false)
                    .addComponent(labels[27], GroupLayout.Alignment.TRAILING, 0, 0, Short.MAX_VALUE)
                    .addComponent(labels[23], GroupLayout.Alignment.TRAILING, 0, 0, Short.MAX_VALUE)
                    .addComponent(labels[15], 0, 0, Short.MAX_VALUE)
                    .addComponent(labels[4], 0, 0, Short.MAX_VALUE)
                    .addComponent(labels[3], GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(labels[11], 0, 0, Short.MAX_VALUE)
                    .addComponent(labels[19], 0, 0, Short.MAX_VALUE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(labels[6])
                    .addComponent(labels[5])
                    .addComponent(labels[12])
                    .addComponent(labels[16])
                    .addComponent(labels[20])
                    .addComponent(labels[24])
                    .addComponent(labels[28]))
                .addGap(44, 44, 44)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING, false)
                        .addComponent(labels[25], 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[21], 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[17], GroupLayout.PREFERRED_SIZE, 19, Short.MAX_VALUE)
                        .addComponent(labels[9], 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[13], GroupLayout.PREFERRED_SIZE, 28, Short.MAX_VALUE)
                        .addComponent(labels[29], 0, 0, Short.MAX_VALUE))
                    .addComponent(labels[7]))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(labels[8])
                    .addComponent(labels[30])
                    .addComponent(labels[10])
                    .addComponent(labels[14])
                    .addComponent(labels[18])
                    .addComponent(labels[22])
                    .addComponent(labels[26]))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[3])
                    .addComponent(labels[7])
                    .addComponent(labels[5])
                    .addComponent(labels[8]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[4])
                    .addComponent(labels[9])
                    .addComponent(labels[6])
                    .addComponent(labels[10]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[11])
                    .addComponent(labels[13])
                    .addComponent(labels[12])
                    .addComponent(labels[14]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[15])
                    .addComponent(labels[17])
                    .addComponent(labels[16])
                    .addComponent(labels[18]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[19])
                    .addComponent(labels[21])
                    .addComponent(labels[20])
                    .addComponent(labels[22]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[23])
                    .addComponent(labels[25])
                    .addComponent(labels[24])
                    .addComponent(labels[26]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[27])
                    .addComponent(labels[29])
                    .addComponent(labels[28])
                    .addComponent(labels[30])))
        );
        labels[31].setForeground(new java.awt.Color(21, 116, 173));
        labels[31].setText("Pakete");
        labels[38].setForeground(new java.awt.Color(21, 116, 173));
        labels[38].setText("Kaufkurs (€)");

        GroupLayout jPanel2Layout = new GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(labels[31])
                    .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
                        .addComponent(labels[37], GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[36], GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[35], GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[34], GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[33], GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(labels[32], GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 23, Short.MAX_VALUE)))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(labels[44])
                    .addComponent(labels[39])
                    .addComponent(labels[38])
                    .addComponent(labels[40])
                    .addComponent(labels[41])
                    .addComponent(labels[42])
                    .addComponent(labels[43]))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[31])
                    .addComponent(labels[38]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[32])
                    .addComponent(labels[39]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[33])
                    .addComponent(labels[40]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[34])
                    .addComponent(labels[41]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[35])
                    .addComponent(labels[42]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[36])
                    .addComponent(labels[43]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[37])
                    .addComponent(labels[44]))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jTextField1.setText(" Index");
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField1FocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField1FocusLost(evt);
            }
        });

        jButton2.setText("Aktiendetails");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton9.setText("Transaktionen");
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        labels[47].setText("labels[47]");

        jButton5.setText("Depotdetails");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        GroupLayout jPanel3Layout = new GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextField1)
                    .addComponent(jButton2, GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jButton9, GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton5, GroupLayout.PREFERRED_SIZE, 108, GroupLayout.PREFERRED_SIZE)
                    .addComponent(labels[47]))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                        .addGap(7, 7, 7)
                        .addComponent(jButton2, GroupLayout.PREFERRED_SIZE, 22, GroupLayout.PREFERRED_SIZE))
                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(labels[47])
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButton9, GroupLayout.Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, 49, GroupLayout.PREFERRED_SIZE)))
        );

        labels[1].setText("Börse");

        labels[2].setText("Depot");

        jButton1.setText("Börse beenden");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        GroupLayout jPanel4Layout = new GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator3, GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
            .addGroup(GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(371, Short.MAX_VALUE)
                .addComponent(jButton1, GroupLayout.PREFERRED_SIZE, 108, GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jSeparator3, GroupLayout.PREFERRED_SIZE, 10, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(labels[1])
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 415, Short.MAX_VALUE)
                .addComponent(labels[2])
                .addGap(19, 19, 19))
            .addGroup(GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(jSeparator2, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                    .addGroup(GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jPanel1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSeparator1, GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(labels[1])
                    .addComponent(labels[2]))
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator2, GroupLayout.PREFERRED_SIZE, 10, GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, GroupLayout.PREFERRED_SIZE, 5, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addGap(16, 16, 16)
                .addComponent(jPanel4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        
        // Anfangsgröße des Hauptfensters
        setSize(600, 500);
    }// </editor-fold>

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
        
        System.exit(0);
    }

    private void jTextField1FocusGained(java.awt.event.FocusEvent evt) {
        
        jTextField1.setText("");
    }

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {
        // Depotdetails
        depotdetails.setVisible(true);
    }

    private void jTextField1FocusLost(java.awt.event.FocusEvent evt) {
        
        if(jTextField1.getText().compareTo("")== 0){
            jTextField1.setText(" Index");
        }
    }

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
        
        int i = 0;
        try{
            i= Integer.parseInt(jTextField1.getText());
        }
        catch(NumberFormatException nfe){
	}
        if (i>0 && i<aktienliste.length){
            aktiendetails.aktualisieren(i-1);
            aktiendetails.setLocation(100, 300);
            aktiendetails.setVisible(true);
        }
        else {
            JOptionPane.showMessageDialog(null, "Keine passende Aktie gefunden.", "Achtung", JOptionPane.OK_CANCEL_OPTION);
        }
        
    }

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {
        
        transaktionen.setLocation(200, 300);
        transaktionen.setVisible(true);
    }
    
    /**
    * Setzt den Text für ein Label
    * @param i Index des Labels
    * @param t Neuer Text des Labels
    *  
    */
    public void setLabelText(int i, String t){
        labels[i].setText(t);
    }
    /**
    * Setzt die Farbe eines Labels
    * @param i Index des Labels
    * @param c Farbe
    *  
    */
    public void setLabelForeground(int i, java.awt.Color c){
        labels[i].setForeground(c);
    }
}
